/**
 * @author tothsz
 */


// in_ragne
function in_range( value, range) {
	return( value < range[0] || value > range[1] )?false:true;
}

// later
jQuery.later = function (_o, _s, _m) {
	var that = _o,
		args = Array.prototype.slice.apply(arguments, [3]);
	if (typeof _m === 'string')_m = that[_m];
	time = setTimeout(function () {_m.apply(that, args);}, _s);
	return time;	
};

// cookie
jQuery.cookie = {
	
	set: function(name, value, expires, path, domain, secure) {
		var now = new Date();	
		var base = new Date(0);
		var skew = base.getTime();
		if (skew > 0)
			date.setTime(date.getTime() - skew);		
		
		now.setTime(now.getTime() + expires);
		var curCookie = name + "=" + escape(value) +
			((expires) ? "; expires=" + now.toGMTString() : "") +
			((path) ? "; path=" + path : "") +
			((domain) ? "; domain=" + domain : "") +
			((secure) ? "; secure" : "");
		document.cookie = curCookie;
	},
	
	get: function(name) {
		var dc = document.cookie;
		var prefix = name + "=";
		var begin = dc.indexOf("; " + prefix);
		if (begin == -1) {
			begin = dc.indexOf(prefix);
			if (begin != 0) return null;
		} else
			begin += 2;
		var end = document.cookie.indexOf(";", begin);
		if (end == -1)
			end = dc.length;
		return unescape(dc.substring(begin + prefix.length, end));
	},
	
	del: function(name, path, domain) {
		if (this.get(name)) {
			document.cookie = [name,"=",((path) ? "; path=" + path : ""),((domain) ? "; domain=" + domain : ""),"; expires=Thu, 01-Jan-70 00:00:01 GMT"].join('');
		}
	}
};

// events
$.fn.extend({
	target: function(){
		return this[0].target || this[0].srcElement;
	},
	stopPropagation: function() {
		if (this[0].stopPropagation) {
		  this[0].stopPropagation();
		} 
		else {
		  this[0].cancelBubble = true;
		}
	},
	preventDefault: function() {
		if (this[0].preventDefault) {
		  this[0].preventDefault();
		} 
		else {
		  this[0].returnValue = false;
		}
	},
	stop: function() {
		this.stopPropagation(this[0]);
		this.preventDefault(this[0]);
	}, 	
	
	pointerX: function() {
		return this[0].pageX || (this[0].clientX +
		  (document.documentElement.scrollLeft || document.body.scrollLeft));
	},
	pointerY: function() {
		return this[0].pageY || (this[0].clientY +
		  (document.documentElement.scrollTop || document.body.scrollTop));
	},
	listen: function( _type, _fn){
		this.each(function(){
			this.addEventListener( _type,_fn );
		});
		return this;
	}
});


jQuery.fn.extend({
  externalURL: function() {
    return this.click(function() { 
		var request = new air.URLRequest(this.href);
		try { air.navigateToURL(request); } catch (e) {}
		return false;
	});
  }
});





// clone
function clone(object) {
	function F() {}
	F.prototype = object;
	return new F;
}
// extend
function extend(subClass, superClass) {
  var F = function() {};
  F.prototype = superClass.prototype;
  subClass.prototype = new F();
  subClass.prototype.constructor = subClass;

	subClass.superclass = superClass.prototype;
	if(superClass.prototype.constructor == Object.prototype.constructor) {
		superClass.prototype.constructor = superClass;
  }
}
// augment
function augment(receivingClass, givingClass) {
  if(arguments[2]) { // Only give certain methods.
    for(var i = 2, len = arguments.length; i < len; i++) {
      receivingClass.prototype[arguments[i]] = givingClass.prototype[arguments[i]];
    }
  } 
  else { // Give all methods.
    for(methodName in givingClass.prototype) { 
      if(!receivingClass.prototype[methodName]) {
        receivingClass.prototype[methodName] = givingClass.prototype[methodName];
      }
    }
  }
}

// Interface Constructor.

var Interface = function(name, methods) {
    if(arguments.length != 2) {
        throw new Error("Interface constructor called with " + arguments.length
          + "arguments, but expected exactly 2.");
    }
    
    this.name = name;
    this.methods = [];
    for(var i = 0, len = methods.length; i < len; i++) {
        if(typeof methods[i] !== 'string') {
            throw new Error("Interface constructor expects method names to be " 
              + "passed in as a string.");
        }
        this.methods.push(methods[i]);        
    }    
};    

// Interface Static class method.

Interface.ensureImplements = function(object) {
    if(arguments.length < 2) {
        throw new Error("Function Interface.ensureImplements called with " + 
          arguments.length  + "arguments, but expected at least 2.");
    }

    for(var i = 1, len = arguments.length; i < len; i++) {
        var intrface = arguments[i];
        if(intrface.constructor !== Interface) {
            throw new Error("Function Interface.ensureImplements expects arguments "   
              + "two and above to be instances of Interface.");
        }
        
        for(var j = 0, methodsLen = intrface.methods.length; j < methodsLen; j++) {
            var method = intrface.methods[j];
            if(!object[method] || typeof object[method] !== 'function') {
                throw new Error("Function Interface.ensureImplements: object " 
                  + "does not implement the " + intrface.name 
                  + " interface. Method " + method + " was not found.");
            }
        }
    } 
};